{% load static %}
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1,shrink-to-fit=no">
    <title>
      {% block title %}{% endblock %} | FOSSCell
    </title>

    <style>
      #loader {
        transition: all 0.3s ease-in-out;
        opacity: 1;
        visibility: visible;
        position: fixed;
        height: 100vh;
        width: 100%;
        background: #fff;
        z-index: 90000;
      }

      #loader.fadeOut {
        opacity: 0;
        visibility: hidden;
      }

      .spinner {
        width: 40px;
        height: 40px;
        position: absolute;
        top: calc(50% - 20px);
        left: calc(50% - 20px);
        background-color: #333;
        border-radius: 100%;
        -webkit-animation: sk-scaleout 1.0s infinite ease-in-out;
        animation: sk-scaleout 1.0s infinite ease-in-out;
      }

      @-webkit-keyframes sk-scaleout {
        0% { -webkit-transform: scale(0) }
        100% {
          -webkit-transform: scale(1.0);
          opacity: 0;
        }
      }

      @keyframes sk-scaleout {
        0% {
          -webkit-transform: scale(0);
          transform: scale(0);
        } 100% {
          -webkit-transform: scale(1.0);
          transform: scale(1.0);
          opacity: 0;
        }
      }
    </style>
    <link href="/static/dash/assets/style.css" rel="stylesheet">
    <link href="/static/assets/css/typeahead.css" rel="stylesheet">

    <!-- Specific Page CSS goes HERE -->
    {% block stylesheets %}{% endblock stylesheets %}

  </head>
  <body class="app">
    <!-- @TOC -->
    <!-- =================================================== -->
    <!--
      + @Page Loader
      + @App Content
          - #Left Sidebar
              > $Sidebar Header
              > $Sidebar Menu

          - #Main
              > $Topbar
              > $App Screen Content
    -->

    <!-- @Page Loader -->
    <!-- =================================================== -->
    <div id="loader">
      <div class="spinner"></div>
    </div>

    <script>
      window.addEventListener('load', function load() {
        const loader = document.getElementById('loader');
        setTimeout(function() {
          loader.classList.add('fadeOut');
        }, 300);
      });
    </script>

    <!-- @App Content -->
    <!-- =================================================== -->
    <div>

      {% include 'dash/includes/sidenav.html' %}

      <!-- #Main ============================ -->
      <div class="page-container">

        {% include 'dash/includes/navigation.html' %}

        <!-- ### $App Screen Content ### -->
        <main class="main-content bgc-grey-100">
          <div id="mainContent">

            {% block content %}{% endblock content %}  
          
          </div>
        </main>

        {% include 'dash/includes/footer.html' %}

    </div>
  
    <script type="text/javascript" src="/static/dash/assets/vendor.js"></script>
    <script type="text/javascript" src="/static/dash/assets/bundle.js"></script>
    <script type="text/javascript" src="/static/assets/js/jquery-3.4.1.min.js"></script>
    <script type="text/javascript" src="/static/assets/js/handlebars.min-v4.7.6.js"></script>
    <script type="text/javascript" src="/static/typeahead/typeahead.bundle.js"></script>
    <script type="text/javascript">
      var remote_url = "{% url 'search-api' %}?q=%QUERY";

      var fosscell_objects = new Bloodhound({
          datumTokenizer: function (datum) {
              return Bloodhound.tokenizers.whitespace(datum.value);
          },
          queryTokenizer: Bloodhound.tokenizers.whitespace,
          remote: {
              url: remote_url,
              replace: function(_url){
                return _url.replace('%QUERY', $('#ls_query').val())
              },
              filter: function (fosscell_objects) {
                  console.log(fosscell_objects);
                  // Map the remote source JSON array to a JavaScript object array
                  return $.map(fosscell_objects.results, function (fosscell_object) {
                    return {tt_display: fosscell_object.username || fosscell_object.topic, ...fosscell_object}
                  });
              }
          }
      });

      $ls_user_select = $('input.ls-user-select')
      var members = new Bloodhound({
          datumTokenizer: function (datum) {
              return Bloodhound.tokenizers.whitespace(datum.value);
          },
          queryTokenizer: Bloodhound.tokenizers.whitespace,
          remote: {
              url: remote_url,
              replace: function(_url){
                query = $ls_user_select.val()
                query = query.replace(/(group:)|(member:)/, '')
                console.log(query)
                console.log(_url)
                return _url.replace('%QUERY', 'member:'+query)
              },
              filter: function (members) {
                  console.log(members)
                  // Map the remote source JSON array to a JavaScript object array
                  return $.map(members.results, function (member) {
                    return {tt_display: member.username, ...member}
                  });
              }
          }
      });

      // Initialize the Bloodhound suggestion engine
      members.initialize()
      fosscell_objects.initialize();

      Handlebars.registerHelper('equals', function(lvalue, rvalue, options) {
        if (arguments.length < 3)
            throw new Error("Handlebars Helper equal needs 2 parameters");
        if( lvalue!=rvalue ) {
            return options.inverse(this);
        } else {
            return options.fn(this);
        }
      });

      function loadHandlebarsTemplate(url, callback) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var raw = xhr.responseText;
                var compiled = Handlebars.compile(raw);
                callback(compiled);
            }
        };
        xhr.send();     
      }

      loadHandlebarsTemplate('{% static "templates/result-object.html" %}', (sugg_templ) => {
        var _suggestion = sugg_templ
        {% verbatim %}
        var _footer = Handlebars.compile("<small>Searched for '{{query}}'</small>")
        {% endverbatim %}
        // Instantiate the Typeahead UI
        var ls_query = $('#ls_query')
        console.log(ls_query)
        ls_query.typeahead(null, {
            limit: 16,
            display: 'tt_display',
            source: fosscell_objects.ttAdapter(),
            templates: {
                suggestion: _suggestion,
                footer: _footer
            }
        });

        ls_query.on('typeahead:select', (evt, item) => {
          window.location.assign(item.url)
        })

        // User select typeahead, only found on some pages
        $ls_user_select.typeahead(null, {
          limit: 8,
          display: 'tt_display',
          source: members.ttAdapter(),
          templates: {
              suggestion: _suggestion,
          }
        })
        $ls_user_select.on('typeahead:select', (evt, item) => {
          $ls_user_select.val(item.username)
        })
        $('.search-input span.twitter-typeahead').css('width', '100%')
      })

    </script>
    <!-- Specific Page JS goes HERE -->
    {% block javascripts %}{% endblock javascripts %}

  </body>

</html>
